<!DOCTYPE html>
<html>
    <head>
        <title>Session 4</title>
    </head>
    <body>
        <script>
            var obj = {
                name : "js",
                8 : "number",
                [1] : "array",
                //[1,2] : "array", //doesnot take array as key
                array : [1,2],
                object : { name:"inner obj" }, // takes object as value
                f1 : function(){
                    return("function inside object");
                }
            };
            document.write(obj.name);
            document.write("<br>"+obj[8]); // objects accept numbers as keys
            //document.write("<br>"+obj[[1,2]]);
            document.write("<br>"+obj.array);
            document.write("<br>"+obj.object);
            document.write("<br>"+obj.f1());
            document.write("<br>"+Object.keys(obj));
            //object methods
            document.write("<br><br><b>Object Methods: </b>");
            var ob = new Object();
            document.write("<br>"+ob);
            //defineProperty() method
            Object.defineProperty(ob,'p1',{ 
                value : "pavani1",
                writable: true
            });
            document.write("<br>"+ob.p1);
            //defineProperties() method
            Object.defineProperties(ob,{
                p2: { value:"pavani2",writable: true },
                p3: { value: 10,writable: true }
            });
            document.write("<br>"+ob.p2);
            document.write("<br>"+ob.p3);
            var ob_dup = {
                p1: "pavani",
                p2: "techigai",
                p4: 20
            };
            //assign()
            var assign_obj = Object.assign(ob,ob_dup);
            document.write("<br>assign p1"+ ob.p1);
            //entries()
            for(var [key,value] of Object.entries(ob)){
                document.write("<br>"+key+": "+value);
            }
            //freeze()
            //The freeze method throws an error in strict mode when trying to change
            // Object.freeze(ob);
            // ob.p4 = "pav";
            // document.write(obj.p4);
            // factory functions are those that return an object
            function fact_fun(firstname,lastname){
                var person = {
                    fname : firstname,
                    lname : lastname,
                };
                return person;
            }
            var person1 = fact_fun("Durga","Pavani");
            document.write("<br>"+person1.fname+ " " + person1.lname);
            var person2 = fact_fun("pavani","kotamarthi");
            document.write("<br>"+person2.fname+ " " + person2.lname);
            //Getter and Setter functions
            var person_name = {
                fname: "firstname",
                lname: "lastname",
                get fullname(){
                    return this.fname + " " + this.lname;
                }
            }
            document.write("<br>Using get: " + person_name.fullname);
            var pers_name = {
                fname: "",
                lname: "",
                set fullname(full_name){
                    [this.fname,this.lname] = full_name.split(" ");
                },
                get fullname(){
                    return this.fname + " " + this.lname;
                }
            };
            pers_name.fullname = "first last";
            document.write("<br>Using set: "+pers_name.fullname);
            //promises
            document.write("<br><br><b>Promises:</b>");
            var promise_fun = new Promise(function(fulfilled,rejected){
                var x = 10;
                if(x>10){ 
                    fulfilled("Greater than 10");
                }
                else{
                    rejected("Less than 10 or equal");
                }
            });
            promise_fun.then(
                function(value){
                    document.write("<br>"+value);
                },
                function(error){
                    document.write("<br>"+error);
                }
            );
            // multiple then functions will be executed for single promise
            promise_fun.then(
                function(value1){
                    document.write("<br>then1: "+value1);
                },
                function(error1){
                    document.write("<br>then1: "+error1);
                }
            );
            //error handling using catch
            var prom = new Promise(function(resolve,reject){
                var x = 0;
                if(x==1){
                    resolve("yes");
                }
                else{
                    reject("error");
                }
            });
            prom.then(
                (value)=>document.write("<br">+value)
            ).catch((error) => document.write("<br>"+error));
            var s1;
            var s2;
            var prom1 = new Promise(function(res,rej){
                var x=1;
                if(x==0){
                    //s1 = setTimeout(res,3000,"catch1 res");
                    res("catch1 res");
                }
                else{
                    //s2 = setTimeout(rej,3000,"catch2 rej");
                    rej("catch2 rej");
                }
            });
            prom1.then(
                (value)=>document.write("<br>"+value),
                (error)=>document.write("<br>"+error)
            );
            prom1.catch(
                (value1)=>document.write("<br>catch1: "+value1)
            );
            prom1.catch(
                (value2)=>document.write("<br>catch2: "+value2)
            );
            //promise.all()
            var pro1 = new Promise((res,rej)=>rej("Rejected"));
            var pro2 = new Promise((f,d)=>f("d"));
            var pro3 = new Promise((ful,dec)=>dec("declined"));
            Promise.all([pro1,pro2,pro3]).then(
                (value1)=>document.write("<br>"+value1),
                (error)=>document.write("<br>"+error)
            );
            //setTimeout
            // var x = setTimeout(myfun,3000);
            // function myfun(){
            //     document.write("<br>Delayed after 3 sec");
            // }
            //clearTimeout(x);
            //promise without then or catch
            var prms = new Promise(
                function(res,rej) {
                    // console.log("promise"); This line will also be printed
                    var x=1;
                    if(x){res("yes");}
                    else{res("No");}
                }
            );
            function res(value){
                console.log(value);
            }              // res and rej callback functions in promise are not executed without using then
            function rej(error){
                console.log(error);
            }
            prms.then(
                (value)=>console.log(value),
                (error)=>console.log(error)
            );
            var i = {
                name: "pavani",
                company: "techigai"
            }
            Object.freeze(i);
            i.name = "durga";//object i in freeze state 
            console.log(i);
            //var j = Object.assign(i); Here j is also freezed bcs we are directly assigning i to j.
            var j = Object.assign({},i);
            i.name = "durga"; //Object i is still in freeze but assigned to j
            console.log(i);
            console.log(j);
            j.name = "pavs";
            i = Object.assign(j);
            console.log(i);
        </script>
    </body>
</html>